/*******************************************************************************************
 *                                                                                         *
 *----------- multi-knapsack problem described in Zitzler's PhD Dissertation --------------*
 *                                                                                         *
 *                                                          Xianming Chen, Feb 23, 2001     *
 *-------------------------- see the Makefile for usage -----------------------------------*
 *******************************************************************************************/


#include <moea/NSGA.h>
#include "knapsack.h"

void  main(int argc, char** argv) {

  NSGA nsga; nsga.maximize();
  nsga.nicheRadius(115);

  int items = 250;
  nsga.addParameter("items of each knapsack", "items", "items", Int, &items);

  nsga.readCommandLine(argc, argv);  

  initProblem(items, nsga.objectiveDimensions());

  IND ind(items, knapsackEvaluator);
  ind.metric(DefaultGenotypicHammingDistance);

  nsga.initialize(ind);
  startLog(nsga);

  while( !nsga.done() ) { 
    if(nsga.currentGeneration() % 100 == 0) {
      nsga.parameters();
      nsga.printScores();
    }
    nsga.step();
  }
  nsga.parameters();
  nsga.printScores();
  endLog(nsga);
}

