/*******************************************************************************************
 *                                                                                         *
 *----------- Multi-knapsack problem described in Zitzler's PhD Dissertation --------------*
 *                                                                                         *
 *                                                          Xianming Chen, Feb 23, 2001    *
 *-------------------------- see the Makefile for usage -----------------------------------*
 *******************************************************************************************/


#include <moea/PTSGA.h>
#include "knapsack.h"

void  main(int argc, char** argv) {

  PTSGA ptsga;
  ptsga.maximize();
  ptsga.pCrossover(0.8);
  ptsga.pMutate(0.01);
  ptsga.maxDepth(15);
  ptsga.initDepth(3);
  ptsga.maxGenerations(750);

  int items = 250;
  ptsga.addParameter("items of each knapsack", "items", "items", Int, &items);
  ptsga.readCommandLine(argc, argv);  

  initProblem(items, ptsga.objectiveDimensions());
  IND ind(items, knapsackEvaluator);

  ptsga.initialize(ind);
  startLog(ptsga);

  while( !ptsga.done() ) { 
    if(ptsga.currentGeneration() % 100 == 0) {
      ptsga.parameters();
      ptsga.printScores();
    }
    ptsga.step();
  }
  ptsga.parameters();
  ptsga.printScores();
  endLog(ptsga);
}




