/*******************************************************************************************
 *                                                                                         *
 *----------- multi-knapsack problem described in Zitzler's PhD Dissertation --------------*
 *                                                                                         *
 *                                                          Xianming Chen, Feb 23, 2001    *
 *-------------------------- see the Makefile for usage -----------------------------------*
 *******************************************************************************************/


#include <moea/SPEA.h>
#include "knapsack.h"

void  main(int argc, char** argv) {

  SPEA spea; spea.maximize();

  int items = 250;
  spea.addParameter("items of each knapsack", "items", "items", Int, &items);

  spea.readCommandLine(argc, argv);  

  initProblem(items, spea.objectiveDimensions());

  IND ind(items, knapsackEvaluator);
  ind.metric(DefaultObjectiveDistance);

  spea.initialize(ind);
  startLog(spea);

  while( !spea.done() ) { 
    if(spea.currentGeneration() % 100 == 0) {
      spea.parameters();
      spea.printScores();
    }
    spea.step();
  }
  spea.parameters();
  spea.printScores();
  endLog(spea); //log experimental data.
}


