/*******************************************************************************************
 *                                                                                         *
 *----------- multi-knapsack problem described in Zitzler's PhD Dissertation --------------*
 *                                                                                         *
 *                                                          Xianming Chen, Feb 23, 2001     *
 *-------------------------- see the Makefile for usage -----------------------------------*
 *******************************************************************************************/


#include <moea/VEGA.h>
#include "knapsack.h"

void  main(int argc, char** argv) {
 
  VEGA vega; vega.maximize();

  int items = 250;
  vega.addParameter("items of each knapsack", "items", "items", Int, &items);

  vega.readCommandLine(argc, argv);  

  initProblem(items, vega.objectiveDimensions());

  IND ind(items, knapsackEvaluator);
  vega.initialize(ind);
  startLog(vega);

  while( !vega.done() ) { 
    if(vega.currentGeneration() % 100 == 0) {
      vega.parameters();
      vega.printScores();
    }
    vega.step();
  }
  vega.parameters();
  vega.printScores();
  endLog(vega);
}
